%{
/* this is a test file for macyacc It should be renamed as something.y.
 * MacYacc expects files with the extension '.y' or '.Y'
 * it then produces a compilable file with the extension '.c'.
 * If requested, it produces a '.h' include file and a '.o'
 * grammar file (a list of the states, shifts, etc.)
 * The '.c' file should be compiled and linked in a environment
 * that simulates a standard terminal (such as linking with the
 * Consular stdlib).
 * The parser code lives in the data fork of mac yacc. Extract it w/ FEDIT
 * or whatever if you would like to look at it or modify it.
 * As an additional bonus, yacc contains a resource type: cstr which others
 * may find useful.
 *
 * for additional information see:
 *    Unix Utilities Manual   (Steve Johnson)
 *    The Unix Programming Environment (Kernighan & Pike) (excellent book)
 *    Intro to Compiler Construction w/ Unix (Schreiner & Friedman)
 *
 * this program is copyrighted by no-one.  Have fun.
 */
#include <stdio.h>
%}
%start list

%token DIGIT 

%left '+' '-'
%left '*' '/' '%'
%left UMINUS

%%

list:	
	|	list stat '\r'
	|	list error '\r'
			{	yyerrok;}
	;

stat	:	expr	{	printf("%d\n",$1); }
;

expr:	'(' expr ')'
			{	$$ = $2; }
	|	expr '+' expr
			{	$$ = $1 + $3; }
	|	expr '-' expr
			{	$$ = $1 - $3; }
	|	expr '*' expr
			{	$$ = $1 * $3; }
	|	expr '/' expr
			{	$$ = $1 / $3; }
	|	expr '%' expr
			{	$$ = $1 % $3; }
	|	'-' expr	%prec UMINUS
			{ 	$$ = - $2; }
	|	number
	;
	
number:	DIGIT
	{ $$ = $1;}
	|	number DIGIT
			{	$$ = 10 *$1 + $2; }
	;
	
%%
yylex()
{
	int c;
	
	while((c = putchar(getchar())) == ' ');
	
	if( isdigit(c)) {
		yylval = c - '0';
		return(DIGIT);
	}
 else if(tolower(c) == 'q') c = 0;
	return(c);
}
yyerror(str)
  char *str;
{
	printf("%s\n",str);
	return(0);
}
main()
{
	printf("Calculate Now(q to quit)...\n");
	yyparse();
}
